/* tgc.h is part of proxyLL package.
   Copyright (C) 2009	KHI (bluedragon000@operamail.com)
  
*/

#ifndef _TGC_H_
#define _TGC_H_

//#include <time.h>
#include "includes.h"

#define TGC_USER_PORT		80
#define TGC_USER_MAX		50

#define CERTF  			"cert.pem"
#define KEYF   			"privkey.pem"
#define CERTF_ABS  		"/var/proxyLL/cert.pem"
#define KEYF_ABS		"/var/proxyLL/privkey.pem"
#define PASSWORD 		"test"

#define TGC_DEFAULT_LOGFILE	"/dev/null"
#define TGC_DEFAULT_LOGLEVEL	5
#define TGC_BUFFER_SIZE 	33000 /*32768 */

// time intervals between each connectin attempt to LL
#define  TGC_TIMEOUT	10000000   /* 1000000 per second */
#define  TGC_RETRY	3

#define MAX_USERNAME	30
#define	IS_OWNER	'O'
#define	IS_DESK		'C'

#define	STATUS_ERROR	"X"
#define	STATUS_FULL	"F"
#define	STATUS_OK	"O"

#define	SOCKET_NORMAL	"N"
#define	SOCKET_SSL	"S"

#define	STATUS_AUTH	"A"
#define	STATUS_NONAUTH	"E"

#define SESSION_DIGIT   8

// to queue up the incoming connections from the operators to pair them up together later
typedef struct _socketq {
	int	sd;		// socket descriptor
	SSL*	ssl;
	unsigned long ip;	// incoming client's IP
	long	sn;		// session number
	int	retry;		// authentication retry count
	char	username[MAX_USERNAME]; // owner's name
	int	userlen;
	long	si;		// socket incoming time
	int	isUser;
	struct _socketq	*next;
	struct _socketq	*prev;
} socket_queue;


typedef struct {
	unsigned short  	port;
	unsigned char		mysql_ip[20];
	socket_queue		*socketq;	// (operator/client)
	int			sd_accept;
	int			user_max;
	int			isSSL;
	int			isAUTH;
	SSL_METHOD 		*meth;
	SSL_CTX			*ctx;
	unsigned char   	buf[TGC_BUFFER_SIZE];
} TGC;


typedef struct {
	char	*name;
	char	*addr;
	struct  sockaddr_in *sin;
	int	sd;
} host_info;

/* OP Codes */

/*
Messege Structure:
0: OP Code (1B)
1: Msg. Len (xB)
2: DATA
*/

/*-----------------------------------------*/

/* Error codes  */
#define E_TGC_OK		0
#define E_TGC_NOCANDO		-1
#define E_TGC_BADOPCODE		-2
#define E_TGC_IE		-3
#define E_TGC_READ		-4
#define E_TGC_WRITE		-5


/* function prototypes */
int tgc_pre_init(TGC *tgc);
int tgc_post_init(TGC *tgc);
void tgc_shutdown(TGC *tgc);

int tgc_run(TGC *tgc);

#endif

