/* utils.h is part of proxyLL package.
   Copyright (C) 2009	KHI (bluedragon000@operamail.com)
  
*/


#ifndef __UTILS_H__
#define __UTILS_H__

#define DEBUG

#ifdef __cplusplus
  extern "C" {
#endif 

#ifndef MAX_PATH
#define  MAX_PATH	254
#endif

void init_log(int dlevel, char *dbg_filename, int daemon);

void close_log(void);

#ifdef __STDC__
void print_log(int dlevel, char *format_str, ...);
#else
void print_log(va_alist);
#endif

#ifdef __STDC__
void print_log_msg(int dlevel, const char *func, char *format_str, ...);
#else
void print_log_msg(va_alist);
#endif

#if __GNUC__ > 3
	#ifdef DEBUG
	#define	PRINT_LOG(l, ...)	print_log_msg((l), __FUNCTION__, __VA_ARGS__)
	#else
	#define	PRINT_LOG(l, ...)	
	#endif
#else
	#ifdef DEBUG
	#define	PRINT_LOG(l, args...)	print_log_msg((l), __FUNCTION__, args)
	#else
	#define	PRINT_LOG(l, args...)	
	#endif
#endif

int 	big_endian(void);
int 	strequal(char *s1, char *s2);
void 	strlower(char *s);
void 	strupper(char *s);
void 	string_replace(char *s, char old_str, char new_str);
int	strnum(char *s);
void 	become_daemon(void);
void 	change_user(void);
int 	xioctl(int fd, int request, void *argp);
int 	read_data(int fd, unsigned char *buf, int len);
int 	parse_host(char *hostport, char *host, unsigned short *port);
int 	connect_server(char *host, int port);
int	open_server_socket(int port);
void*   ipc_connect();
long	get_current();

RETSIGTYPE sig_cld();
#ifdef HAVE_LIBWRAP
int	peer_ok(char *prog, int sd);
#endif
int 	accept_connection(int sd_accept, struct sockaddr_in *addr, socklen_t *in_addrlen);


#ifdef __cplusplus
  }
#endif 

#endif

